
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/file.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#ifdef sgi
#include <sys/sysmacros.h>
#endif
#ifdef SYSV
#include <string.h>
#include <unistd.h>
#else /* not SYSV */
#include <sys/ioctl.h>
#include <strings.h>
#endif /* SYSV */

#ifdef ibm
#include <sys/select.h>
#endif /* ibm */

#ifndef FD_SETSIZE
#ifndef VMS
#include <sys/param.h>
#define FD_SETSIZE	((NOFILE > sizeof (long)) ? sizeof (long) : NOFILE)
#else
#define FD_SETSIZE      256
#endif /* !VMS */
#define NBBY    8
typedef long    fd_mask;
#define NFDBITS (sizeof(fd_mask) * NBBY)        /* bits per mask */
#ifndef howmany
#define howmany(x, y)   (((x)+((y)-1))/(y))
#endif /* !howmany */
typedef struct fd_set {
        fd_mask fds_bits[howmany(FD_SETSIZE, NFDBITS)];
} fd_set;
#define FD_SET(n, p)    ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define FD_CLR(n, p)    ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define FD_ISSET(n, p)  ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)      bzero((char *)(p), sizeof(*(p)))
#endif /* FD_SETSIZE */


/*
** allow for mobility of the pty master/slave directories
*/
#ifdef hpux
#define	PTYDEV		"/dev/ptym/ptyxx"
#define TTYDEV		"/dev/pty/ttyxx"
#define PTYCHAR1	"zyxwvutsrqp"
#define	PTYCHAR2	"fedcba9876543210"
#else	/* !hpux */
#define	PTYDEV		"/dev/ptyxx"
#define	TTYDEV		"/dev/ttyxx"
#define	PTYCHAR1	"pqrstuvwxyzPQRSTUVWXYZ"
#define	PTYCHAR2	"0123456789abcdef"
#endif	/* !hpux */

#define BUFSIZE 256
#define LOGFILE "/tmp/xpttyd_log"
#define TIMEDOUT_RETRY_INTERVAL     180
#define CONNREFUSED_RETRY_INTERVAL   60
#define LINK_RETRY  10

		/* structure for each host -> xterm connection */
typedef struct connection_table {
	char node_name[80];		/* xterm node name */
	char pty[80];			/* pseudo tty port on host */
	char oldttydev[80];		/* old tty used for reopen */
	char ttydev[80];		/* slave pseudo tty port on host */
	char ptydev[80];		/* master pseudo tty port on host */
	int port;			/* xterm port to connect to */
	int active;			/* connection state */
	int ptyfd;			/* pseudo tty file descriptor  */
	int local_socket;		/* host socket for comm to xterm */
	int pending;			/* connection pending */
	int error;			/* connection error */
	int logged;			/* connection error message logged */
	int timeout;			/* retry time in seconds */
	struct sockaddr_in xterm;	/* socket connection info to xterm */
	struct connection_table *next;	/* pointer to next connection_table */
	int fromfd;			/* from file descriptor */
	int tofd;			/* to file descriptor */
	int cbuf_cnt;			/* unwritten buffer count */
	int written;			/* written buffer count */
	char cbuf[BUFSIZE];		/* buffer to hold data */
} connection_table;

